<%-- 
    Document   : functions
    Created on : Oct 28, 2017, 8:18:02 AM
    Author     : ADMIN
--%>
<%@page import = "org.asynchttpclient.*" 
        import = "java.sql.Timestamp"
        import = "java.util.*"
        import = "java.io.*"
        import = "java.net.*"
        import = "org.json.JSONArray"
        import = "org.json.JSONObject"
        import = "javax.net.ssl.HttpsURLConnection"
        %>
<%@page 
        import= "java.nio.charset.Charset"
        import= "java.security.InvalidKeyException"
        import= "java.security.NoSuchAlgorithmException"
        import= "javax.crypto.Mac"
        import= "javax.crypto.SecretKey"
        import= "javax.crypto.spec.SecretKeySpec"
        %>

<%!
    public static String signature(String endpoint, Map<String, String> params, String clientSecret) {

        // ensure we iterate through the keys in sorted order
        List<String> values = new ArrayList<>(params.size());
        int index = 0;
        String sig = build_query(endpoint, params, true);

        SecretKey secretKey = null;

        byte[] keyBytes = clientSecret.getBytes();
        secretKey = new SecretKeySpec(keyBytes, "HmacSHA512");

        byte[] text = sig.getBytes();

        Mac mac = null;
        try {
            mac = Mac.getInstance("HmacSHA512");
            mac.init(secretKey);
            return bytesToHex(mac.doFinal(text)).toLowerCase();
        } catch (NoSuchAlgorithmException e) {
            return "";
        } catch (InvalidKeyException e) {
            return "";
        }
    }

    //HELPER METHODS
    private static final String HMAC_SHA512 = "HmacSHA512";
    private static final Charset UTF_8 = Charset.forName("UTF-8");
    private final static char[] hexArray = "0123456789ABCDEF".toCharArray();

    public static String bytesToHex(byte[] bytes) {
        char[] hexChars = new char[bytes.length * 2];
        for (int j = 0; j < bytes.length; j++) {
            int v = bytes[j] & 0xFF;
            hexChars[j * 2] = hexArray[v >>> 4];
            hexChars[j * 2 + 1] = hexArray[v & 0x0F];
        }
        return new String(hexChars);
    }

    public static String build_query(String endpoint, Map<String, String> params, boolean mode) {

        // ensure we iterate through the keys in sorted order
        List<String> values = new ArrayList<>(params.size());
        int index = 0;
        String query = "";
        try {
            List<String> keys = new ArrayList<String>(params.keySet());
            Collections.sort(keys);
            for (String key : keys) {
                if (index == 0) {
                    query += String.format("%s=%s", key, URLEncoder.encode(params.get(key), "UTF-8"));
                } else {
                    query += String.format("&%s=%s", key, URLEncoder.encode(params.get(key), "UTF-8"));
                }
                index++;
            }
            if (mode) {
                return query = endpoint + '?' + query;
            } else {
                return query = query;
            }
        } catch (UnsupportedEncodingException e) {
            return "";
        }
    }
    public static String call_WPC(String endpoint, Map<String, String> params) throws Exception{
        URL obj = new URL(endpoint);
        HttpsURLConnection con = (HttpsURLConnection) obj.openConnection();
        con.setRequestMethod("POST");
        String urlParameters = build_query(endpoint, params, false);
        con.setDoOutput(true);
        DataOutputStream wr = new DataOutputStream(con.getOutputStream());
        wr.writeBytes(urlParameters);
        wr.flush();
        wr.close();
        BufferedReader reader = new BufferedReader(new InputStreamReader(con.getInputStream()));
        StringBuilder sb = new StringBuilder();
        String line = null;
        while ((line = reader.readLine()) != null) {
            sb.append(line);
        }
        reader.close();
        return sb.toString();
    }
%>