<%-- 
    Document   : return
    Created on : Oct 28, 2017, 8:18:16 AM
    Author     : ADMIN
--%>
<%@include file="functions.jsp" %>
<%
    //World Payments Corp Config
    boolean wpcTestMode = true;
    String wpcEndpoint = "";
    if (wpcTestMode) {
        //TEST MODE ENDPOINT
        wpcEndpoint = "https://securetest.paycec.com/redirect-service";
    } else {
        //LIVE MODE ENDPOINT
        wpcEndpoint = "https://secure.paycec.com/redirect-service";
    }
    
    //Get the transaction detail from Secure PayCEC
    String purchaseDetailsEndpoint = wpcEndpoint + "/purchase-details";
    
    String merchantName = "<your_vendor_name>";                  //Replace it by your vendor user name
    String merchantSecretKey = "<your_vendor_secret_key>";       //Replace it by your vendor secret key
    String token = request.getParameter("token");
    
    HashMap<String, String> params = new HashMap<>();
    params.put("merchantName", merchantName);
    params.put("merchantSecretKey", merchantSecretKey);
    params.put("token", token);

    String sig = signature(purchaseDetailsEndpoint, params, merchantSecretKey);
    params.put("sig", sig);
    
    //Call to Secure PayCEC Service to get the transaction details
    String json = call_WPC(purchaseDetailsEndpoint, params);
    JSONObject jsonObj = new JSONObject(json);
    Object aObj = jsonObj.get("isSuccessful");
    if ((jsonObj != null) && aObj.equals("true")) {
        //Charged successfully!
        
        out.print("Successfully charged!" + "</br>");
        out.print("- Timestamp: " + jsonObj.get("timestamp") + "</br>");
        out.print("- Transaction ID: " + jsonObj.get("transactionId") + "</br>");
        out.print("- Token: " + jsonObj.get("token") + "</br>");
        out.print("- Request ID: " + jsonObj.get("requestId") + "</br>");
    } else {
        //Error handling
        out.print("We've got some errors retrieving from WPC service" + "</br>");
        out.print("- Error Code: " + jsonObj.get("errorCode") + "</br>");
        out.print("- Error Message: " + jsonObj.get("message") + "</br>");
        if (jsonObj.get("errorField") != null) {
            out.print("- Error Field:" + jsonObj.get("errorField") + "</br>");
        }
    }
%>